Fix NoMethodError on HEAD requests to AccountController#register
2017-04-19 19:06 - Holger Just

Status: Closed Start date:

Priority: Normal Due date:

Assignee: Jean-Philippe Lang % Done: 0%
Category: Accounts / authentication Estimated time: 0.00 hour
Target version: 3.2.7

Description

The attached patch fixes a NoMethodError when attempting to run a HEAD request against AccountController#register.

The cause of the bug is that HEAD requests did not trigger the check for request.get?.

Associated revisions

Revision 16554 - 2017-05-13 11:32 - Jean-Philippe Lang
Only perform login action on explicit POST (#25653).

Patch by Holger Just.

Revision 16555 - 2017-05-13 11:32 - Jean-Philippe Lang

Render register page on all non-POST requests to account#register (#25653).

Patch by Holger Just.

Revision 16562 - 2017-05-27 09:34 - Jean-Philippe Lang
Merged r16554 and r16555 (#25653).

Revision 16563 - 2017-05-27 09:34 - Jean-Philippe Lang
Merged r16554 and r16555 (#25653).

History

#1 - 2017-04-20 10:53 - Go MAEDA

- Target version set to 3.2.7

| cannot reproduce the problem but | think that merging this fix is very reasonable because lines after
source:tags/3.3.3/app/controllers/account_controller.rb@16536#L130 should be executed only when request is POST.

$ curl -v --head http://localhost:3000/account/register
& Trying ::1...

* TCP_NODELAY set

* Connected to localhost (::1) port 3000 (#0)

HEAD /account/register HTTP/1.1

Host: localhost:3000

User-Agent: curl/7.51.0

Accept: */*

AV V V V V

HTTP/1.1 200 OK
HTTP/1.1 200 OK

#2 - 2017-04-20 13:48 - Holger Just

Hmmm, we had indeed only seen the error on Redmine 3.3, more specifically in
http://www.redmine.org/projects/redmine/repository/revisions/16536/entry/tags/3.3.3/app/controllers/account_controller.rb#L.148.

In current trunk, this code is now a bit different so that the exception doesn't occur anymore. However, it would still be desirable to not perform the
registration from a HEAD request, as Go Maeda wrote above.

Now that | had a look around, the same issue is present in AccountController#login. There, it's again not an exception on HEAD but Redmine still
attempts a login from the supplied URL parameters which is not desirable.
#3 - 2017-04-20 13:52 - Holger Just
- File 0002-Only-perform-login-action-on-explicit-POST.patch added

The attached patch also fixed the additional issue described in #25653#note-2

#4 - 2017-05-13 11:33 - Jean-Philippe Lang
- Status changed from New to Resolved

- Assignee set to Jean-Philippe Lang

Patches committed, thanks.

#5 - 2017-05-27 09:34 - Jean-Philippe Lang

- Status changed from Resolved to Closed

Files

0001-Render-register-page-on-all-non-POST-requests-to-acc.patch 935 Bytes
0002-Only-perform-login-action-on-explicit-POST.patch 1004 Bytes
